import socket
import util
import time

#manually edit these if i2p/bob are running on a networked computer
BOB_IP = '127.0.0.1'
COMP_IP = '127.0.0.1'

class BobConn(socket.socket):
    def __init__(self):
        socket.socket.__init__(self)
        self.fileobj = self.makefile("r")
        self.connect((BOB_IP,2827))
        ver = self.fileobj.readline()
        util.Check(self.fileobj.readline())
    def sendcheck(self,msg):
        self.send(msg)
        return util.Check(self.fileobj.readline())
    def setnick(self,nick):
        self.sendcheck("setnick %s\n"%nick)
    def getnick(self,nick):
        self.sendcheck("getnick %s\n"%nick)
    def newkeys(self):
        self.public = self.sendcheck("newkeys\n")
    def getdest(self):
        self.public = self.sendcheck("getdest\n")
        self.b32 = util.b32fromb64(self.public)+'.b32.i2p'
    def getkeys(self):
        self.private = self.sendcheck("getkeys\n")
    def setkeys(self,private):
        self.public = self.sendcheck("setkeys %s\n"%private)
    def SetIN(self,inhost,inport):
        self.sendcheck('inhost %s\n'%inhost)
        self.sendcheck('inport %s\n'%inport)
    def SetOUT(self,outhost,outport):
        self.sendcheck("outhost %s\n"%outhost)
        self.sendcheck("outport %s\n"%outport)
    def start(self):
        self.sendcheck("start\n")
    def stop(self):
        self.sendcheck("stop\n")
    def quiet(self,boole):##"true" or "false"
        self.sendcheck("quiet %s\n"%boole)
    def show(self):
        m = self.sendcheck("show\n").split(' ')
        return {'nickname':m[1],'starting':m[3],'running':m[5],'stopping':m[7],'keys':m[9],
                'quiet':m[11],'inport':m[13],'inhost':m[15],'outport':m[17],'outhost':m[19]}
    def list(self):
        self.send("list\n")
        tuns = []
        while True:
            rslt = self.fileobj.readline()
            if rslt.startswith("OK"):
                return tuns
            else:
                tuns.append(rslt.rstrip("\r\n"))
    def closeall(self):#WARN this will close all tunnels on bob
        tuns = self.list()
        for tun in tuns:
            prts = tun.split(' ')#TODO#redo this with a parse bobinfo function ^ similar to show
            self.getnick(prts[2])
            if prts[6] == "true":
                self.stop()
            while True:
                try:
                    self.clear()
                    break
                except:
                    time.sleep(1)
    def clear(self):
        self.sendcheck("clear\n")
    def quit(self):
        self.sendcheck("quit\n")